using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.Scrapping.Cqrs;

public record DeleteScrappingItemCommand(string Id) : IRequest<bool>;

public class DeleteScrappingItemHandler : IRequestHandler<DeleteScrappingItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteScrappingItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteScrappingItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}